"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var chalk_1 = require("chalk");
var tslint_1 = require("tslint");
/**
 * Rule that walks through every identifier that is part of Angular Material and replaces the
 * outdated name with the new one.
 */
var Rule = (function (_super) {
    __extends(Rule, _super);
    function Rule() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    Rule.prototype.applyWithProgram = function (sourceFile, program) {
        return this.applyWithWalker(new CheckClassDeclarationMiscWalker(sourceFile, this.getOptions(), program));
    };
    return Rule;
}(tslint_1.Rules.TypedRule));
exports.Rule = Rule;
var CheckClassDeclarationMiscWalker = (function (_super) {
    __extends(CheckClassDeclarationMiscWalker, _super);
    function CheckClassDeclarationMiscWalker() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    CheckClassDeclarationMiscWalker.prototype.visitClassDeclaration = function (declaration) {
        var _this = this;
        if (declaration.heritageClauses) {
            declaration.heritageClauses.forEach(function (hc) {
                var classes = new Set(hc.types.map(function (t) { return t.getFirstToken().getText(); }));
                if (classes.has('MatFormFieldControl')) {
                    var sfl = declaration.members
                        .filter(function (prop) { return prop.getFirstToken().getText() === 'shouldFloatLabel'; });
                    if (!sfl.length) {
                        _this.addFailureAtNode(declaration, "Found class \"" + chalk_1.bold(declaration.name.text) + "\" which extends" +
                            (" \"" + chalk_1.bold('MatFormFieldControl') + "\". This class must define") +
                            (" \"" + chalk_1.green('shouldLabelFloat') + "\" which is now a required property."));
                    }
                }
            });
        }
    };
    return CheckClassDeclarationMiscWalker;
}(tslint_1.ProgramAwareRuleWalker));
exports.CheckClassDeclarationMiscWalker = CheckClassDeclarationMiscWalker;
//# sourceMappingURL=checkClassDeclarationMiscRule.js.map