"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var chalk_1 = require("chalk");
var tslint_1 = require("tslint");
/**
 * Rule that walks through every identifier that is part of Angular Material and replaces the
 * outdated name with the new one.
 */
var Rule = (function (_super) {
    __extends(Rule, _super);
    function Rule() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    Rule.prototype.applyWithProgram = function (sourceFile, program) {
        return this.applyWithWalker(new CheckIdentifierMiscWalker(sourceFile, this.getOptions(), program));
    };
    return Rule;
}(tslint_1.Rules.TypedRule));
exports.Rule = Rule;
var CheckIdentifierMiscWalker = (function (_super) {
    __extends(CheckIdentifierMiscWalker, _super);
    function CheckIdentifierMiscWalker() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    CheckIdentifierMiscWalker.prototype.visitIdentifier = function (identifier) {
        if (identifier.getText() === 'MatDrawerToggleResult') {
            this.addFailureAtNode(identifier, "Found \"" + chalk_1.bold('MatDrawerToggleResult') + "\" which has changed from a class type to a" +
                " string literal type. Code may need to be updated");
        }
        if (identifier.getText() === 'MatListOptionChange') {
            this.addFailureAtNode(identifier, "Found usage of \"" + chalk_1.red('MatListOptionChange') + "\" which has been removed. Please listen" +
                (" for " + chalk_1.bold('selectionChange') + " on " + chalk_1.bold('MatSelectionList') + " instead"));
        }
    };
    return CheckIdentifierMiscWalker;
}(tslint_1.ProgramAwareRuleWalker));
exports.CheckIdentifierMiscWalker = CheckIdentifierMiscWalker;
//# sourceMappingURL=checkIdentifierMiscRule.js.map