import { RuleFailure, Rules } from 'tslint';
import * as ts from 'typescript';
import { ExternalResource } from '../tslint/component-file';
import { ComponentWalker } from '../tslint/component-walker';
/**
 * Rule that walks through every component decorator and updates their inline or external
 * templates.
 */
export declare class Rule extends Rules.AbstractRule {
    apply(sourceFile: ts.SourceFile): RuleFailure[];
}
export declare class SwitchTemplateElementSelectorsWalker extends ComponentWalker {
    visitInlineTemplate(template: ts.StringLiteral): void;
    visitExternalTemplate(template: ExternalResource): void;
    /**
     * Replaces the outdated name in the template with the new one and returns an updated template.
     */
    private replaceNamesInTemplate(node, templateContent);
    private createReplacementsForOffsets(node, update, offsets);
}
